VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.2#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VBC ZipInfo"
   ClientHeight    =   6120
   ClientLeft      =   150
   ClientTop       =   780
   ClientWidth     =   18795
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   408
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   1253
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog cdOpenZip 
      Left            =   30
      Top             =   30
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSComctlLib.ListView lvZip 
      Height          =   5925
      Left            =   4170
      TabIndex        =   1
      Top             =   90
      Width           =   14535
      _ExtentX        =   25638
      _ExtentY        =   10451
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   0
   End
   Begin MSComctlLib.TreeView tvZip 
      Height          =   5925
      Left            =   90
      TabIndex        =   0
      Top             =   90
      Width           =   4005
      _ExtentX        =   7064
      _ExtentY        =   10451
      _Version        =   393217
      Style           =   7
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Menu mnu_OpenZip 
      Caption         =   "ffnen"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

Private Sub Form_Load()

    Dim lvCH As ColumnHeader

    With tvZip

        .LineStyle = tvwRootLines
        .Indentation = 20
        .LabelEdit = tvwManual
        .HideSelection = False

    End With

    With lvZip

        .View = lvwReport

        Set lvCH = .ColumnHeaders.Add(, , "Name")
        lvCH.Width = 150
        
        .ColumnHeaders.Add , , "Typ"

        Set lvCH = .ColumnHeaders.Add(, , "Komprimierte Gre")
        lvCH.Alignment = lvwColumnRight
        
        .ColumnHeaders.Add , , "Kennwortgeschtzt"
        .ColumnHeaders.Add , , "Methode"

        Set lvCH = .ColumnHeaders.Add(, , "Gre")
        lvCH.Alignment = lvwColumnRight
        
        .ColumnHeaders.Add , , "Verhltnis"
        .ColumnHeaders.Add , , "nderungsdatum"
        .ColumnHeaders.Add , , "CRC-32"

    End With

End Sub

Private Sub SetLvItems(ByVal sPath As String)

    Dim xItem As ListItem
    Dim tFileInfo As FileInfo

    ' Info zu einer bestimmten Datei oder Ordner auslesen
    tFileInfo = GetZipFileFolderInfo(sPath)

    Set xItem = lvZip.ListItems.Add(, , tFileInfo.FileName)

    xItem.SubItems(1) = tFileInfo.FileType
    xItem.SubItems(2) = FileSizeInKB(tFileInfo.PackedSize)
    xItem.SubItems(3) = tFileInfo.HasAPassword
    xItem.SubItems(4) = tFileInfo.Method
    xItem.SubItems(5) = FileSizeInKB(tFileInfo.Size)
    xItem.SubItems(6) = tFileInfo.Ratio
    xItem.SubItems(7) = tFileInfo.Date
    xItem.SubItems(8) = tFileInfo.CRC32

End Sub

Private Function FileSizeInKB(ByVal sStr As String) As String

    Dim aStr() As String
    Dim sBytes As String
    Dim dBytes As Double
    Dim dRet As Double

    If sStr <> "" Then

        aStr() = Split(sStr, " ")
        sBytes = Replace$(aStr(0), ",", ".")

        Select Case UCase(aStr(1))

        Case "BYTES"
            dBytes = Val(sBytes)

        Case "KB"
            dBytes = Val(sBytes) * 1024

        Case "MB"
            dBytes = Val(sBytes) * (1024 ^ 2)

        Case "GB"
            dBytes = Val(sBytes) * (1024 ^ 3)

        End Select

        dRet = dBytes / 1024

        If dRet < 0.5 Then

            dRet = dRet + 1

        End If

        FileSizeInKB = Format$(dRet, "#,###,###,###") & " KB"

    End If

End Function

Private Function NodeExists(ByVal sStr As String) As Boolean

    Dim xNode As Node

    On Error GoTo ErrorHandler

    Set xNode = tvZip.Nodes(sStr)

    NodeExists = True

    Exit Function

ErrorHandler:

    NodeExists = False

End Function

Private Sub FillTvLv(ByVal sPath As String)

    Dim lItem As Long
    Dim lCount As Long
    Dim sZipFile As String
    Dim sZipPath As String
    Dim sZipFileFolder() As String
    Dim sZipSubFileFolder() As String
    Dim xNode As Node

    sZipFile = sPath
    lvZip.ListItems.Clear

    If NodeExists(sZipFile) = False Then

        Set xNode = tvZip.Nodes.Add(, , sZipFile, sZipFile)

    Else

        Set xNode = tvZip.Nodes(sZipFile)

    End If

    ' alle Ordner auslesen
    lCount = EnumZipFile(sZipFile, SHCONTF_FOLDERS, sZipFileFolder)

    If lCount > 0 Then

        For lItem = 0 To lCount - 1

            sZipPath = sZipFile & "\" & sZipFileFolder(lItem)

            If NodeExists(sZipPath) = False Then

                Call tvZip.Nodes.Add(sZipFile, tvwChild, sZipPath, sZipFileFolder( _
                    lItem))

            End If

            ' Infos auslesen
            Call SetLvItems(sZipPath)

            ' Unterordner auslesen
            If EnumZipFile(sZipPath, SHCONTF_FOLDERS, sZipSubFileFolder) > 0 Then

                If NodeExists(sZipPath & "\" & sZipSubFileFolder(0)) = False Then

                    ' nur einen Unterordner einfgen wegen dem + vor dem Node
                    Call tvZip.Nodes.Add(sZipPath, tvwChild, sZipPath & "\" & _
                        sZipSubFileFolder(0), sZipSubFileFolder(0))

                End If

            End If

        Next

    End If

    ' alle Dateien im Ordner auslesen
    lCount = EnumZipFile(sZipFile, SHCONTF_NONFOLDERS, sZipFileFolder)

    If lCount > 0 Then

        For lItem = 0 To lCount - 1

            sZipPath = sZipFile & "\" & sZipFileFolder(lItem)

            ' Infos auslesen
            Call SetLvItems(sZipPath)

        Next

    End If

    tvZip.SetFocus
    xNode.Selected = True

End Sub

Private Sub mnu_OpenZip_Click()

    With cdOpenZip

        .FileName = vbNullString
        .DefaultExt = "*.zip"
        .Filter = "ZipFile|*.zip"
        .ShowOpen

        If .FileName <> vbNullString Then

            tvZip.Nodes.Clear
            lvZip.ListItems.Clear
            
            Call FillTvLv(.FileName)

        End If

    End With

End Sub

Private Sub tvZip_Collapse(ByVal Node As MSComctlLib.Node)

    Call FillTvLv(Node.FullPath)

End Sub

Private Sub tvZip_Expand(ByVal Node As MSComctlLib.Node)

    Call FillTvLv(Node.FullPath)

End Sub

Private Sub tvZip_NodeClick(ByVal Node As MSComctlLib.Node)

    Call FillTvLv(Node.FullPath)

End Sub

